import { AbstractPath } from './AbstractPath.js';
import { Util } from '../../lab/util/Util.js';
export class BrachistoPaths {
    constructor() {
        throw '';
    }
    ;
}
BrachistoPaths.en = {
    BRACH_PATH: 'brachistochrone',
    BRACH_SQUARED: 'brachistochrone-squared',
    CIRCLE_ARC: 'circle',
    LINEAR_PATH: 'linear',
    PARABOLA_DOWN: 'parabola-down',
    PARABOLA_UP: 'parabola-up'
};
BrachistoPaths.de_strings = {
    BRACH_PATH: 'Brachistochrone',
    BRACH_SQUARED: 'Brachistochrone-quadriert',
    CIRCLE_ARC: 'Kreis',
    LINEAR_PATH: 'Linear',
    PARABOLA_DOWN: 'Parabola-ab',
    PARABOLA_UP: 'Parabola-auf'
};
BrachistoPaths.i18n = Util.LOCALE === 'de' ? BrachistoPaths.de_strings : BrachistoPaths.en;
Util.defineGlobal('sims$roller$BrachistoPaths', BrachistoPaths);
export class LinearPath extends AbstractPath {
    constructor() {
        super(BrachistoPaths.en.LINEAR_PATH, BrachistoPaths.i18n.LINEAR_PATH, 0, 6, false);
    }
    ;
    getClassName() {
        return 'LinearPath';
    }
    ;
    x_func(t) {
        return t;
    }
    ;
    y_func(t) {
        return -(2.0 / 3.0) * t;
    }
    ;
}
Util.defineGlobal('sims$roller$LinearPath', LinearPath);
export class BrachistochronePath extends AbstractPath {
    constructor() {
        super(BrachistoPaths.en.BRACH_PATH, BrachistoPaths.i18n.BRACH_PATH, 0, 2 * Math.PI, false);
    }
    ;
    getClassName() {
        return 'BrachistochronePath';
    }
    ;
    x_func(t) {
        if (t > 2 * Math.PI)
            t = 2 * Math.PI;
        if (t < 0)
            t = 0;
        return 1.00133 * (t - Math.sin(t));
    }
    ;
    y_func(t) {
        if (t > 2 * Math.PI)
            return t - 2 * Math.PI;
        else if (t < 0)
            return -t;
        else
            return -1.00133 * (1 - Math.cos(t));
    }
    ;
}
Util.defineGlobal('sims$roller$BrachistochronePath', BrachistochronePath);
export class ParabolaUpPath extends AbstractPath {
    constructor() {
        super(BrachistoPaths.en.PARABOLA_UP, BrachistoPaths.i18n.PARABOLA_UP, -2, 8, false);
    }
    ;
    getClassName() {
        return 'ParabolaUpPath';
    }
    ;
    x_func(t) {
        return t;
    }
    ;
    y_func(t) {
        return -2.0 + (2.0 / 9.0) * (t - 3.0) * (t - 3.0);
    }
    ;
}
Util.defineGlobal('sims$roller$ParabolaUpPath', ParabolaUpPath);
export class Brachistochrone2Path extends AbstractPath {
    constructor() {
        super(BrachistoPaths.en.BRACH_SQUARED, BrachistoPaths.i18n.BRACH_SQUARED, 0, 2 * Math.PI, false);
    }
    ;
    getClassName() {
        return 'Brachistochrone2Path';
    }
    ;
    x_func(t) {
        if (t > 2 * Math.PI)
            t = 2 * Math.PI;
        if (t < 0)
            t = 0;
        return 1.00133 * (t - Math.sin(t));
    }
    ;
    y_func(t) {
        if (t > 2 * Math.PI)
            return t - 2 * Math.PI;
        else if (t < 0)
            return -t;
        else {
            const d = 1 - (1 - Math.cos(t)) / 2.0;
            return 2 * 1.00133 * (-1 + d * d);
        }
    }
    ;
}
Util.defineGlobal('sims$roller$Brachistochrone2Path', Brachistochrone2Path);
export class ParabolaDownPath extends AbstractPath {
    constructor() {
        super(BrachistoPaths.en.PARABOLA_DOWN, BrachistoPaths.i18n.PARABOLA_DOWN, -2, 8, false);
    }
    ;
    getClassName() {
        return 'ParabolaDownPath';
    }
    ;
    x_func(t) {
        return t;
    }
    ;
    y_func(t) {
        return -0.1666667 * (t + 0.5) * (t + 0.5) + 0.04166667;
    }
    ;
}
Util.defineGlobal('sims$roller$ParabolaDownPath', ParabolaDownPath);
export class CircleArcPath extends AbstractPath {
    constructor() {
        super(BrachistoPaths.en.CIRCLE_ARC, BrachistoPaths.i18n.CIRCLE_ARC, -Math.PI, 0, false);
    }
    ;
    getClassName() {
        return 'CircleArcPath';
    }
    ;
    x_func(t) {
        return 3 + (13.0 / 4.0) * Math.cos(t);
    }
    ;
    y_func(t) {
        return (13.0 / 4.0 - 2.0) + (13.0 / 4.0) * Math.sin(t);
    }
    ;
}
Util.defineGlobal('sims$roller$CircleArcPath', CircleArcPath);
