import { Util } from '../../lab/util/Util.js';
import { AbstractPath } from './AbstractPath.js';
export class OvalPath extends AbstractPath {
    constructor(straight, name, localName) {
        name = name || OvalPath.en.NAME;
        localName = localName || OvalPath.i18n.NAME;
        super(name, localName, 0, 0, true);
        straight = straight ?? 2.0;
        this.s_ = straight;
        this.t0_ = Math.PI / 2;
        this.t1_ = Math.PI;
        this.t2_ = this.t1_ + this.s_;
        this.t3_ = this.t2_ + Math.PI;
        this.t4_ = this.t3_ + this.s_;
        this.t5_ = this.t4_ + Math.PI / 2;
        this.setStartTValue(this.t0_);
        this.setFinishTValue(this.t5_);
    }
    ;
    toString() {
        return super.toString().slice(0, -1)
            + ', straight: ' + Util.NF(this.s_) + '}';
    }
    ;
    getClassName() {
        return 'OvalPath';
    }
    ;
    x_func(t) {
        if (t < this.t1_)
            return Math.cos(t);
        else if (t < this.t2_)
            return -1;
        else if (t < this.t3_)
            return Math.cos(Math.PI + t - this.t2_);
        else if (t < this.t4_)
            return 1;
        else if (t < this.t5_)
            return Math.cos(t - this.t4_);
        else
            return 0;
    }
    ;
    y_func(t) {
        if (t < this.t1_)
            return this.s_ + Math.sin(t);
        else if (t < this.t2_)
            return this.s_ - (t - this.t1_);
        else if (t < this.t3_)
            return Math.sin(Math.PI + t - this.t2_);
        else if (t < this.t4_)
            return t - this.t3_;
        else if (t < this.t5_)
            return this.s_ + Math.sin(t - this.t4_);
        else
            return 0;
    }
    ;
}
OvalPath.en = {
    NAME: 'Oval'
};
OvalPath.de_strings = {
    NAME: 'Oval'
};
OvalPath.i18n = Util.LOCALE === 'de' ? OvalPath.de_strings : OvalPath.en;
Util.defineGlobal('sims$roller$OvalPath', OvalPath);
