import { ConcreteVertex } from '../lab/engine2D/ConcreteVertex.js';
import { Polygon } from '../lab/engine2D/Polygon.js';
import { Vector } from '../lab/util/Vector.js';
export function makeBlockRoundEdge() {
    const p = new Polygon('block-round-edge');
    p.startPath(new ConcreteVertex(new Vector(0, 0)));
    p.addStraightEdge(new Vector(2, 0), false);
    p.addStraightEdge(new Vector(2, 1), true);
    p.addCircularEdge(new Vector(0, 1), new Vector(1.0, -0.3), false, true);
    p.addStraightEdge(new Vector(0, 0), false);
    p.finish();
    p.setElasticity(0.8);
    return p;
}
;
export function makeConcaveCirclePoly() {
    const p = new Polygon('concave_circle');
    p.startPath(new ConcreteVertex(new Vector(0, -0.5)));
    p.addStraightEdge(new Vector(3, -0.5), false);
    p.addStraightEdge(new Vector(3, 1), true);
    p.addCircularEdge2(new Vector(0, 1), 2, true, true, false);
    p.addStraightEdge(new Vector(0, -0.5), false);
    p.finish();
    p.setCenterOfMass(new Vector(1.5, 0));
    p.setElasticity(0.8);
    return p;
}
;
export function makeNGon(n, radius) {
    const p = new Polygon('polygon-' + n + '-sides');
    const delta = 2 * Math.PI / n;
    p.startPath(new ConcreteVertex(new Vector(radius, 0)));
    for (let i = 1; i < n; i++) {
        p.addStraightEdge(new Vector(radius * Math.cos(delta * i), radius * Math.sin(delta * i)), i <= n / 2);
    }
    p.addStraightEdge(new Vector(radius, 0), false);
    p.finish();
    p.setCenterOfMass(Vector.ORIGIN);
    p.setMomentAboutCM(radius * radius / 2);
    p.setElasticity(0.8);
    return p;
}
;
